/*
 * Plasma applet to display application window menus
 *
 * Copyright 2010 Canonical Ltd.
 *
 * Authors:
 * - Aurélien Gâteau <aurelien.gateau@canonical.com>
 *
 * License: GPL v3
 */
#ifndef REGISTRAR_H
#define REGISTRAR_H

// Qt
#include <QDBusContext>
#include <QObject>
#include <QWidget> // For WId

class QDBusObjectPath;
class QMenu;

class DBusMenuImporter;

namespace Plasma {
class Applet;
}

class Registrar : public QObject, protected QDBusContext
{
    Q_OBJECT

public:
    Registrar(Plasma::Applet*);

    QMenu* currentMenu() const;

    WId activeWinId() const { return mActiveWinId; }

Q_SIGNALS:
    void currentMenuChanged();

public Q_SLOTS:
    void RegisterWindow(int wid, const QDBusObjectPath& menuObjectPath);

private Q_SLOTS:
    void slotWindowRemoved(WId);
    void updateActiveWinId();
    void slotMenuReadyToBeShown();

private:
    QHash<WId, DBusMenuImporter*> mImporters;
    WId mActiveWinId;
    Plasma::Applet* mApplet;
};

#endif /* REGISTRAR_H */
