/*
 * Plasma applet to display application window menus
 *
 * Copyright 2010 Canonical Ltd.
 *
 * Authors:
 * - Aurélien Gâteau <aurelien.gateau@canonical.com>
 *
 * License: GPL v3
 */
#ifndef WINDOWMENU_H
#define WINDOWMENU_H

// Qt
#include <QMenu>

// KDE
#include <netwm.h>

class QAction;

class WindowMenuManager : public QObject
{
    Q_OBJECT
public:
    WindowMenuManager(QObject*);
    ~WindowMenuManager();

    QMenu* menu() const { return mMenu; }

    void setWinId(WId);

private Q_SLOTS:
    void updateActions();
    void toggleMinimize();
    void toggleMaximize();
    void toggleShade();
    void closeWindow();

private:
    QMenu* mMenu;
    WId mWid;

    QAction* mMinimizeAction;
    QAction* mMaximizeAction;
    QAction* mShadeAction;
    QAction* mCloseAction;

    bool isMinimized() const;
    void toggleNETState(NET::State state);
};



#endif /* WINDOWMENU_H */
